library(gamlss)
library(MuMIn)
library(ape)
library(stats)
setwd('/Users/JIAQ9527/Desktop/Population trends/Analysis')
da <- read.csv('DATA2.csv')
attach(da)
vc_ndvi <- da$NDVI/da$NDVI_SD
vc_evi <- da$EVI/da$EVI_SD
vc_msavi <- da$MSAVI/da$MSAVI_SD
vc_savi <- da$SAVI/da$SAVI_SD

#da2 <- data.frame(year,lake,Land,Water,NDVI,EVI,MSAVI,SAVI,TEMP,PRESIP,BG,TS,SG,GWFG,LWFG,vc_ndvi,vc_evi,vc_msavi,vc_savi,x,y,PL)
da2 <- data.frame(year,lake,Land,Water,NDVI,TEMP,PRESIP,BG,TS,SG,GWFG,LWFG,vc_ndvi,PL)
con <- gamlss.control(n.cyc=50)

bg1 <- gamlss(BG~cs(year)+cs(Land)+cs(TEMP)+cs(PRESIP)+cs(NDVI)+cs(vc_ndvi)+re(random=~1|lake),data=na.omit(da2),family=NBII,control=con)

ts1 <- gamlss(TS~cs(year)+cs(Water)+cs(TEMP)+cs(PRESIP)+cs(NDVI)+cs(vc_ndvi)+re(random=~1|lake),data=na.omit(da2),family=NBII,control=con)

sg1 <- gamlss(SG~cs(year)+cs(Water)+cs(TEMP)+cs(PRESIP)+cs(NDVI)+cs(vc_ndvi)+re(random=~1|lake),data=na.omit(da2),family=NBI,control=gamlss.control(n.cyc=50))

gw1 <- gamlss(GWFG~cs(year)+cs(Land)+cs(TEMP)+cs(PRESIP)+cs(NDVI)+cs(vc_ndvi)+re(random=~1|lake),data=na.omit(da2),family=NBII,control=con)

lw1 <- gamlss(LWFG~cs(year)+cs(Land)+cs(TEMP)+cs(PRESIP)+cs(NDVI)+cs(vc_ndvi)+re(random=~1|lake),data=na.omit(da2),family=NBI,control=con)


bg_st <- stepGAIC(bg1)
ts_st <- stepGAIC(ts1)
sg_st <- stepGAIC(sg1)
gw_st <- stepGAIC(gw1)
lw_st <- stepGAIC(lw1)
ts1.1 <- refit(ts_st)
lw1.1 <- refit(lw_st)

ts <- gamlss(TS~cs(year)+cs(PRESIP)+re(random=~1|lake),data=na.omit(da2),family=NBII,control=con)
sg <- gamlss(SG~cs(year)+cs(TEMP)+re(random=~1|lake),data=na.omit(da2),family=NBI,control=con)
bg <- gamlss(BG~cs(vc_ndvi)+cs(NDVI)+cs(PRESIP)+re(random=~1|lake),data=na.omit(da2),family=NBII,control=con)
gw <- gamlss(GWFG~cs(year)+re(random=~1|lake),data=na.omit(da2),family=NBII,control=con)
gw.1 <- gamlss(GWFG~cs(year)+cs(NDVI)+re(random=~1|lake),data=na.omit(da2),family=NBII,control=con)
lw <- gamlss(LWFG~cs(year)+cs(vc_ndvi)+cs(NDVI)+re(random=~1|lake),data=na.omit(da2),family=NBI,control=con)

term.plot(ts,scheme='lines',pages=1,col.term='black',col.se='black')
term.plot(sg,scheme='lines',pages=1,col.term='black',col.se='black')
term.plot(bg,scheme='lines',pages=1,col.term='black',col.se='black')
term.plot(gw.1,scheme='lines',pages=1,col.term='black',col.se='black')
term.plot(lw,scheme='lines',pages=1,col.term='black',col.se='black')




Rsq(bg1_st) #Pseudo R square for model evaluation

#auto-correlation/covariance function shows litted temporal autocorrelation
acf(residuals(ts))
acf(residuals(sg))
acf(residuals(bg))
acf(residuals(gw.1))
acf(residuals(lw))